<?php

class ReviewController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout = '//layouts/column2';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			// 'postOnly + delete', // we only allow deletion via POST request
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array(
				'allow',
				'actions' => array('create', 'update', 'view', 'delete', 'admin', 'index', 'enable', 'disable'),
				'users' => array('@'),
				'expression' => 'Yii::app()->user->record->level==1',
			),
			array(
				'allow',
				'actions' => array('view', 'my', 'add', 'update', 'create'),
				'users' => array('@'),
				'expression' => 'Yii::app()->user->record->level==2',
			),
			array(
				'allow',
				'actions' => array('view'),
				'users' => array('@'),
				'expression' => 'Yii::app()->user->record->level==3',
			),
			array(
				'deny',
				'users' => array('*'),
			),
		);
	}


	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$model = $this->loadModel($id);
		if ($model == NULL) {
			$this->redirect(array('create', 'id' => $model->paper_id, 'team_id' => $model->team_id));
		} else {
			if(Yii::app()->user->record->division==1){
				if (Yii::app()->request->isAjaxRequest) {
					$this->renderPartial('view', array(
						'model' => $model,
						'weight' => $this->loadWeight(1),
					), false, true);
				} else {
					$this->render('view', array(
						'model' => $model,
						'weight' => $this->loadWeight(1),
					));
				}
			}else{
				if (Yii::app()->request->isAjaxRequest) {
					$this->renderPartial('view_final', array(
						'model' => $model,
						'weight' => $this->loadWeight(2),
					), false, true);
				} else {
					$this->render('view_final', array(
						'model' => $model,
						'weight' => $this->loadWeight(2),
					));
				}
			}

		}
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($id, $team)
	{
		$model = new Review;
		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);
		if (isset($_POST['Review'])) {
			$model->attributes = $_POST['Review'];
			$model->paper_id = $id;
			$model->team_id = $team;
			$model->evaluator_id = YII::app()->user->id;
			$model->created_id = YII::app()->user->id;
			$model->created_date = date('Y-m-d h:i:s');
			$model->status = 1;
			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->id_rating));
				// $this->redirect(array('main/review/my'));
			}
		}
		$this->render('add', array(
			'model' => $model,
			'paper' => $this->loadPaper($id),
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if (isset($_POST['Review'])) {
			$model->attributes = $_POST['Review'];
			$model->update_id = YII::app()->user->id;
			$model->update_date = date('Y-m-d h:i:s');
			$model->type = Yii::app()->user->record->division;
			if($model->type==1){
				$model->value_skor = Review::model()->getTotal($model->id_rating, 2);
				$model->value_total = Review::model()->getTotal($model->id_rating, 1);
			}else{
				$model->value_skor = WeightFinal::model()->getTotal($model->id_rating, 2);
				$model->value_total = WeightFinal::model()->getTotal($model->id_rating, 1);
			}
			if ($model->save()) {
				$this->redirect(array('view', 'id' => $id));
			}
		}

		$this->render('update', array(
			'model' => $model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if (!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider = new CActiveDataProvider('Review');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	// public function actionAdmin()
	// {
	// 	$model = new Review('search');
	// 	$model->unsetAttributes();  // clear any default values
	// 	if (isset($_GET['Review']))
	// 		$model->attributes = $_GET['Review'];

	// 	$data = new Review;
	// 	if (isset($_POST['Review'])) {
	// 		$data->attributes = $_POST['Review'];
	// 		$data->created_id = YII::app()->user->id;
	// 		$data->created_date = date('Y-m-d h:i:s');
	// 		$data->status = 1;
	// 		if ($data->save())
	// 			$this->redirect(array('view', 'id' => $data->id_rating));
	// 	}

	// 	$this->render('admin', array(
	// 		'model' => $model,
	// 		'data' => $data,
	// 	));
	// }

	public function actionAdmin()
	{
		$dataProvider=new CActiveDataProvider('Review', array(
			'criteria'=>array(
				// 'condition' => 'evaluator_id=' . Yii::app()->user->record->id_user,
				'order'=>'id_rating DESC',
			),
			'pagination'=>array(
				'pageSize'=>100000,
			),
		));

		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Review the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model = Review::model()->findByPk($id);
		if ($model === null)
			throw new CHttpException(404, 'The requested page does not exist.');
		return $model;
	}


	public function loadReview($id)
	{
		$model = Review::model()->findByAttributes(array('paper_id' => $id, 'evaluator_id' => YII::app()->user->id));
		return $model;
	}


	public function loadReviews($id)
	{
		$model = Review::model()->findByPk($id);
		return $model;
	}


	public function loadPaper($id)
	{
		$model = Paper::model()->findByPk($id);
		if ($model === null)
			throw new CHttpException(404, 'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Review $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if (isset($_POST['ajax']) && $_POST['ajax'] === 'review-form') {
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}

	public function actionEnable($id)
	{
		$model = $this->loadModel($id);
		$model->status = 1;
		$model->save();
		$this->redirect(array('index'));
	}

	public function actionDisable($id)
	{
		$model = $this->loadModel($id);
		$model->status = 0;
		$model->save();
		$this->redirect(array('index'));
	}

	public function actionMy()
	{
		$dataProvider=new CActiveDataProvider('Review', array(
			'criteria'=>array(
				'condition' => 'evaluator_id=' . Yii::app()->user->record->id_user,
				'order'=>'id_rating DESC',
			),
			'pagination'=>array(
				'pageSize'=>100000,
			),
		));

		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdd($id, $team)
	{
		$cek = $this->loadReview($id);
		if ($cek === NULL) {
			$model = new Review;
			// Uncomment the following line if AJAX validation is needed
			// $this->performAjaxValidation($model);
			if (isset($_POST['Review'])) {
				$model->attributes = $_POST['Review'];
				$model->paper_id = $id;
				$model->team_id = $team;
				$model->evaluator_id = YII::app()->user->id;
				$model->created_id = YII::app()->user->id;
				$model->created_date = date('Y-m-d h:i:s');
				$model->status = 1;
				$model->type = Yii::app()->user->record->division;
				if($model->type==1){
					$model->value_skor = Review::model()->getTotal($model->id_rating, 2);
					$model->value_total = Review::model()->getTotal($model->id_rating, 1);
				}else{
					$model->value_skor = WeightFinal::model()->getTotal($model->id_rating, 2);
					$model->value_total = WeightFinal::model()->getTotal($model->id_rating, 1);
				}
				if ($model->save()) {

					// $description,$activityid,$type,$point,$part,$object
					Activities::model()->my("Penilai an. " . YII::app()->user->record->fullname . " Menilai Peserta an. " . Users::model()->showFullname($model->team_id), 1, 7, 1, 1, $model->team_id);

					// $model->team_id = $model->Paper->researchers_id;
					// $model->update();
					$this->redirect(array('main/review/my'));
				}
			}
			$this->render('add', array(
				'model' => $model,
				'paper' => $this->loadPaper($id),
			));
		} elseif ($cek->team_id == $team && $cek->evaluator_id == YII::app()->user->id) {
			$this->redirect(array('view', 'id' => $cek->id_rating));
		} else {
			throw new CHttpException(500, 'Video Sudah di Nilai.');
		}
	}

	public function loadWeight($type)
	{
		if($type==1){
			$model = Weight::model()->findByPk(1);
		}else{
			$model = WeightFinal::model()->findByPk(1);
		}
		if ($model === null)
			throw new CHttpException(404, 'The requested page does not exist.');
		return $model;
	}
}
